diff mbox series

[2/2] xfs_admin: enable online label getting and setting

Message ID 157530824483.128859.9805424152601641362.stgit@magnolia (mailing list archive)
State Superseded
Headers show
Series xfs_admin: unify online/offline fs label setting | expand

Commit Message

Darrick J. Wong Dec. 2, 2019, 5:37 p.m. UTC
From: Darrick J. Wong <darrick.wong@oracle.com>

Connect xfs_admin -L to the xfs_io label command so that we can get and
set the label for a live filesystem.

Signed-off-by: Darrick J. Wong <darrick.wong@oracle.com>
---
 db/xfs_admin.sh |   42 ++++++++++++++++++++++++++++++++++++++++--
 1 file changed, 40 insertions(+), 2 deletions(-)
diff mbox series

Patch

diff --git a/db/xfs_admin.sh b/db/xfs_admin.sh
index bd325da2..d18959bf 100755
--- a/db/xfs_admin.sh
+++ b/db/xfs_admin.sh
@@ -7,8 +7,30 @@ 
 status=0
 DB_OPTS=""
 REPAIR_OPTS=""
+IO_OPTS=""
 USAGE="Usage: xfs_admin [-efjlpuV] [-c 0|1] [-L label] [-U uuid] device [logdev]"
 
+# Try to find a loop device associated with a file.  We only want to return
+# one loopdev (multiple loop devices can attach to a single file) so we grab
+# the last line and return it if it's actually a block device.
+try_find_loop_dev_for_file() {
+	local x="$(losetup -O NAME -j "$1" 2> /dev/null | tail -n 1)"
+	test -b "$x" && echo "$x"
+}
+
+# See if we can find a mount point for the argument.
+find_mntpt_for_arg() {
+	local arg="$1"
+
+	# See if we can map the arg to a loop device
+	local loopdev="$(try_find_loop_dev_for_file "${arg}")"
+	test -n "$loopdev" && arg="$loopdev"
+
+	# If we find a mountpoint for the device, do a live query;
+	# otherwise try reading the fs with xfs_db.
+	findmnt -t xfs -f -n -o TARGET "${arg}" 2> /dev/null
+}
+
 while getopts "efjlpuc:L:U:V" c
 do
 	case $c in
@@ -16,8 +38,16 @@  do
 	e)	DB_OPTS=$DB_OPTS" -c 'version extflg'";;
 	f)	DB_OPTS=$DB_OPTS" -f";;
 	j)	DB_OPTS=$DB_OPTS" -c 'version log2'";;
-	l)	DB_OPTS=$DB_OPTS" -r -c label";;
-	L)	DB_OPTS=$DB_OPTS" -c 'label "$OPTARG"'";;
+	l)	DB_OPTS=$DB_OPTS" -r -c label"
+		IO_OPTS=$IO_OPTS" -r -c label"
+		;;
+	L)	DB_OPTS=$DB_OPTS" -c 'label "$OPTARG"'"
+		if [ "$OPTARG" = "--" ]; then
+			IO_OPTS=$IO_OPTS" -c 'label -c'"
+		else
+			IO_OPTS=$IO_OPTS" -c 'label -s "$OPTARG"'"
+		fi
+		;;
 	p)	DB_OPTS=$DB_OPTS" -c 'version projid32bit'";;
 	u)	DB_OPTS=$DB_OPTS" -r -c uuid";;
 	U)	DB_OPTS=$DB_OPTS" -c 'uuid "$OPTARG"'";;
@@ -41,6 +71,14 @@  case $# in
 				REPAIR_OPTS=$REPAIR_OPTS" -l '$2'"
 		fi
 
+		# Try making the changes online, if supported
+		if [ -n "$IO_OPTS" ] && mntpt="$(find_mntpt_for_arg "$1")"
+		then
+			eval xfs_io -x -p xfs_admin $IO_OPTS "$mntpt"
+			test "$?" -eq 0 && exit 0
+		fi
+
+		# Otherwise try offline changing
 		if [ -n "$DB_OPTS" ]
 		then
 			eval xfs_db -x -p xfs_admin $DB_OPTS $1